=== modified file 'configure.ac'
--- configure.ac	2009-02-20 22:08:20 +0000
+++ configure.ac	2009-02-22 05:01:28 +0000
@@ -17,8 +17,10 @@
 AM_GNU_GETTEXT()
 
 # Checks for programs.
+YACC=bison
 AC_PROG_CC
 AM_PROG_CC_C_O
+AC_PROG_YACC
 
 # Checks for libraries.
 NIH_INIT([dbus])

=== modified file 'init/Makefile.am'
--- init/Makefile.am	2009-02-20 22:08:20 +0000
+++ init/Makefile.am	2009-02-23 07:33:45 +0000
@@ -5,6 +5,10 @@
 AM_CFLAGS = \
 	$(DBUS_CFLAGS)
 
+## We do this because Autoconf YACC/Bison support is cancer. Here it is doing
+## the moral equivalent of compiling all C files to a.out.
+AM_YFLAGS = --output-file=y.tab.c
+
 AM_CPPFLAGS = \
 	-DLOCALEDIR="\"$(localedir)\"" \
 	-DCONFDIR="\"$(initconfdir)\"" \
@@ -32,7 +36,8 @@
 	event.c event.h \
 	event_operator.c event_operator.h \
 	blocked.c blocked.h \
-	parse_job.c parse_job.h \
+	parse_job.h \
+	parse_job.y \
 	parse_conf.c parse_conf.h \
 	conf.c conf.h \
 	control.c control.h \
@@ -47,7 +52,6 @@
 	$(LTLIBINTL) \
 	$(DBUS_LIBS)
 
-
 com_ubuntu_Upstart_OUTPUTS = \
 	com.ubuntu.Upstart.c \
 	com.ubuntu.Upstart.h

=== modified file 'init/job_class.c'
--- init/job_class.c	2009-02-20 22:18:57 +0000
+++ init/job_class.c	2009-02-23 06:38:20 +0000
@@ -238,6 +238,40 @@
 	return NULL;
 }
 
+/**
+ * job_class_is_valid:
+ * @class: Job class to check.
+ *
+ * Checks to make sure there is no invalid information in this job class (out of
+ * range ulimit values, etc).
+ *
+ * Returns TRUE if the job class is AOK.
+ **/
+int
+job_class_is_valid (JobClass *class)
+{
+	int i;
+
+	if (class->umask & ~0777)
+		return FALSE;
+
+	if (class->oom_adj < -17 || class->oom_adj > 15)
+		return FALSE;
+
+	if (class->nice < -20 || class->nice > 19)
+		return FALSE;
+	
+	for (i = 0; i < RLIMIT_NLIMITS; i++) {
+		if (! class->limits[i])
+			continue;
+		if (class->limits[i]->rlim_cur < 0)
+			return FALSE;
+		if (class->limits[i]->rlim_max < class->limits[i]->rlim_cur)
+			return FALSE;
+	}
+
+	return TRUE;
+}
 
 /**
  * job_class_consider:

=== modified file 'init/job_class.h'
--- init/job_class.h	2009-01-28 01:31:02 +0000
+++ init/job_class.h	2009-02-23 06:38:58 +0000
@@ -164,6 +164,8 @@
 					    const char *name)
 	__attribute__ ((warn_unused_result, malloc));
 
+int         job_class_is_valid             (JobClass *class);
+
 int         job_class_consider             (JobClass *class);
 int         job_class_reconsider           (JobClass *class);
 

=== modified file 'init/parse_job.c'
--- init/parse_job.c	2009-01-29 04:23:21 +0000
+++ init/parse_job.c	2009-02-23 08:09:53 +0000
@@ -1,36 +1,96 @@
-/* upstart
- *
- * parse_job.c - job definition parsing
- *
- * Copyright © 2009 Canonical Ltd.
- * Author: Scott James Remnant <scott@netsplit.com>.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
- */
-
-#ifdef HAVE_CONFIG_H
-# include <config.h>
-#endif /* HAVE_CONFIG_H */
-
-
-#include <sys/time.h>
-#include <sys/resource.h>
-
-#include <limits.h>
+/* A Bison parser, made by GNU Bison 2.3.  */
+
+/* Skeleton implementation for Bison's Yacc-like parsers in C
+
+   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
+   Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301, USA.  */
+
+/* As a special exception, you may create a larger work that contains
+   part or all of the Bison parser skeleton and distribute that work
+   under terms of your choice, so long as that work isn't itself a
+   parser generator using the skeleton or a modified version thereof
+   as a parser skeleton.  Alternatively, if you modify or redistribute
+   the parser skeleton itself, you may (at your option) remove this
+   special exception, which will cause the skeleton and the resulting
+   Bison output files to be licensed under the GNU General Public
+   License without this special exception.
+
+   This special exception was added by the Free Software Foundation in
+   version 2.2 of Bison.  */
+
+/* C LALR(1) parser skeleton written by Richard Stallman, by
+   simplifying the original so-called "semantic" parser.  */
+
+/* All symbols defined below should begin with yy or YY, to avoid
+   infringing on user name space.  This should be done even for local
+   variables, as they might otherwise be expanded by user macros.
+   There are some unavoidable exceptions within include files to
+   define necessary library symbols; they are noted "INFRINGES ON
+   USER NAME SPACE" below.  */
+
+/* Identify Bison output.  */
+#define YYBISON 1
+
+/* Bison version.  */
+#define YYBISON_VERSION "2.3"
+
+/* Skeleton name.  */
+#define YYSKELETON_NAME "yacc.c"
+
+/* Pure parsers.  */
+#define YYPURE 1
+
+/* Using locations.  */
+#define YYLSP_NEEDED 0
+
+
+
+/* Tokens.  */
+#ifndef YYTOKENTYPE
+# define YYTOKENTYPE
+   /* Put the tokens into the symbol table, so that GDB and other debuggers
+      know about them.  */
+   enum yytokentype {
+     MAYBE_NUMBER = 258,
+     MAYBE_UMASK = 259,
+     MAYBE_SIGNAL = 260,
+     KNOWN_STRING = 261,
+     EXEC_LINE = 262,
+     SCRIPT_BODY = 263
+   };
+#endif
+/* Tokens.  */
+#define MAYBE_NUMBER 258
+#define MAYBE_UMASK 259
+#define MAYBE_SIGNAL 260
+#define KNOWN_STRING 261
+#define EXEC_LINE 262
+#define SCRIPT_BODY 263
+
+
+
+
+/* Copy the first part of user declarations.  */
+#line 22 "parse_job.y"
+
+#include <stdio.h>
 #include <stdlib.h>
-#include <string.h>
+#include <ctype.h>
 
 #include <nih/macros.h>
 #include <nih/alloc.h>
